use utf8;

=encoding utf-8

=head1 NAME

WebService::Rakuten - Object interface to Rakuten webservice

=head1 SYNOPSIS

  use WebService::Rakuten;

  my $r = WebService::Rakuten->new(
      output_type  => 'perl',
      developer_id => '0123456789abcdef',
  );

  my $keyword = 'Hello Kitty';
  my $page    = 1;

  my $result_rh = $r->itemsearch($keyword,$page);

=head1 DESCRIPTION

This fills an empty niche for interfacing with the Rakuten
webservice detailed here.

  http://webservice.rakuten.co.jp/

=head1 METHODS

=head2 simplehotelsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item largeClassCode

=over

=item type: String

=back

=item middleClassCode

=over

=item type: String

=back

=item smallClassCode

=over

=item type: String

=back

=item detailClassCode

=over

=item type: String

=back

=item hotelNo

=over

=item type: int(10)

=back

=item latitude

=over

=item type: decimal

=back

=item longitude

=over

=item type: decimal

=back

=item searchRadius

=over

=item type: int

=item default: 1

=back

=item squeezeCondition

=over

=item type: String

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item hits

=over

=item type: long

=back

=item datumType

=over

=item type: int(1)

=item default: 2

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/simplehotelsearch/

=head2 booksgamesearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item hardware

=over

=item type: String

=back

=item makerCode

=over

=item type: String

=back

=item label

=over

=item type: String

=back

=item jan

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 006

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksgamesearch/

=head2 hoteldetailsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item hotelNo B<(required)>

=over

=item type: int(10)

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item datumType

=over

=item type: int(1)

=item default: 2

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/hoteldetailsearch/

=head2 gethotelchainlist

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/gethotelchainlist/

=head2 bookssoftwaresearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item os

=over

=item type: String

=back

=item makerCode

=over

=item type: String

=back

=item label

=over

=item type: String

=back

=item jan

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 004

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/bookssoftwaresearch/

=head2 bookscdsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item artistName

=over

=item type: String

=back

=item label

=over

=item type: String

=back

=item jan

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 002

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/bookscdsearch/

=head2 vacanthotelsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item largeClassCode

=over

=item type: String

=back

=item middleClassCode

=over

=item type: String

=back

=item smallClassCode

=over

=item type: String

=back

=item detailClassCode

=over

=item type: String

=back

=item hotelNo

=over

=item type: int(10)

=back

=item checkinDate B<(required)>

=over

=item type: date

=back

=item checkoutDate B<(required)>

=over

=item type: date

=back

=item adultNum

=over

=item type: int(2)

=item default: 1

=back

=item upClassNum

=over

=item type: int(2)

=item default: 0

=back

=item lowClassNum

=over

=item type: int(2)

=item default: 0

=back

=item infantWithMBNum

=over

=item type: int(2)

=item default: 0

=back

=item infantWithMNum

=over

=item type: int(2)

=item default: 0

=back

=item infantWithBNum

=over

=item type: int(2)

=item default: 0

=back

=item infantWithoutMBNum

=over

=item type: int(2)

=item default: 0

=back

=item roomNum

=over

=item type: int(3)

=item default: 1

=back

=item maxCharge

=over

=item type: long

=item default: '指定無し'

=back

=item minCharge

=over

=item type: long

=item default: '指定無し'

=back

=item latitude

=over

=item type: decimal

=back

=item longitude

=over

=item type: decimal

=back

=item searchRadius

=over

=item type: int

=item default: 1

=back

=item squeezeCondition

=over

=item type: String

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item datumType

=over

=item type: int(1)

=item default: 2

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/vacanthotelsearch/

=head2 booksmagazinesearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item publisherName

=over

=item type: String

=back

=item jan

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 007

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksmagazinesearch/

=head2 itemcodesearch

=head3 Parameters

=over

=item itemCode B<(required)>

=over

=item type: String

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/itemcodesearch/

=head2 bookstotalsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item keyword

=over

=item type: String

=back

=item booksGenreId

=over

=item type: String

=item default: 000

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/bookstotalsearch/

=head2 booksforeignbooksearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item author

=over

=item type: String

=back

=item publisherName

=over

=item type: String

=back

=item isbn

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 005

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksforeignbooksearch/

=head2 genresearch

=head3 Parameters

=over

=item genreId B<(required)>

=over

=item type: int

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/genresearch/

=head2 auctionitemsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item keyword

=over

=item type: String

=back

=item genreId

=over

=item type: long

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item minPrice

=over

=item type: long

=item default: '指定無し'

=back

=item maxPrice

=over

=item type: long

=item default: '指定無し'

=back

=item sort

=over

=item type: String

=item default: '+endTime'

=back

=item blowFlag

=over

=item type: int(1)

=item default: 0

=back

=item itemType

=over

=item type: int(1)

=item default: 0

=back

=item newFlag

=over

=item type: int(1)

=item default: 0

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item imageFlag

=over

=item type: int(1)

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/auctionitemsearch/

=head2 dynamicad

=head3 Parameters

=over

=item url

=over

=item type: String

=back

=item carrier

=over

=item type: int

=item default: 0

=back

=item callBack

=over

=item type: String

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/dynamicad/

=head2 cdsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item keyword

=over

=item type: String

=back

=item genreId

=over

=item type: long

=item default: 0

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item sort

=over

=item type: String

=item default: '-reviewCount'

=back

=item minPrice

=over

=item type: long

=item default: '指定無し'

=back

=item maxPrice

=over

=item type: long

=item default: '指定無し'

=back

=item availability

=over

=item type: int(1)

=item default: 1

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item imageFlag

=over

=item type: int(1)

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=item genreInformationFlag

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/cdsearch/

=head2 booksearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item keyword

=over

=item type: String

=back

=item genreId

=over

=item type: long

=item default: 0

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item sort

=over

=item type: String

=item default: '-reviewCount'

=back

=item minPrice

=over

=item type: long

=item default: '指定無し'

=back

=item maxPrice

=over

=item type: long

=item default: '指定無し'

=back

=item availability

=over

=item type: int(1)

=item default: 1

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item imageFlag

=over

=item type: int(1)

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=item genreInformationFlag

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksearch/

=head2 getareaclass

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/getareaclass/

=head2 hotelranking

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item genre B<(required)>

=over

=item type: String

=item default: 'all'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/hotelranking/

=head2 catalogsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item keyword

=over

=item type: String

=back

=item genreId

=over

=item type: long

=item default: 0

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item sort

=over

=item type: String

=item default: '-registerDate'

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item imageFlag

=over

=item type: int(1)

=item default: 0

=back

=item releaseRange

=over

=item type: int

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=item genreInformationFlag

=over

=item type: String

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/catalogsearch/

=head2 booksdvdsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item artistName

=over

=item type: String

=back

=item label

=over

=item type: String

=back

=item jan

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 003

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksdvdsearch/

=head2 keywordhotelsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item page

=over

=item type: int

=item default: 1

=back

=item hits

=over

=item type: int

=item default: 20

=back

=item sumDisplayFlag

=over

=item type: int(1)

=item default: 0

=back

=item keyword B<(required)>

=over

=item type: String

=back

=item middleClassCode

=over

=item type: String

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/keywordhotelsearch/

=head2 itemranking

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item genreId

=over

=item type: long

=back

=item age

=over

=item type: int

=back

=item sex

=over

=item type: int

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/itemranking/

=head2 auctionitemcodesearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item itemCode B<(required)>

=over

=item type: String

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/auctionitemcodesearch/

=head2 dvdsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item keyword

=over

=item type: String

=back

=item genreId

=over

=item type: long

=item default: 0

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item sort

=over

=item type: String

=item default: '-reviewCount'

=back

=item minPrice

=over

=item type: long

=item default: '指定無し'

=back

=item maxPrice

=over

=item type: long

=item default: '指定無し'

=back

=item availability

=over

=item type: int(1)

=item default: 1

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item imageFlag

=over

=item type: int(1)

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=item genreInformationFlag

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/dvdsearch/

=head2 itemsearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=item default: '指定無し'

=back

=item keyword

=over

=item type: String

=back

=item shopCode

=over

=item type: String

=item default: '指定無し'

=back

=item genreId

=over

=item type: long

=item default: 0

=back

=item catalogCode

=over

=item type: String

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item minPrice

=over

=item type: long

=item default: '指定無し'

=back

=item maxPrice

=over

=item type: long

=item default: '指定無し'

=back

=item availability

=over

=item type: int(1)

=item default: 1

=back

=item field

=over

=item type: int(1)

=item default: 1

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=item imageFlag

=over

=item type: int(1)

=item default: 0

=back

=item orFlag

=over

=item type: int(1)

=item default: 0

=back

=item NGKeyword

=over

=item type: String

=item default: '指定無し'

=back

=item genreInformationFlag

=over

=item type: int(1)

=item default: 0

=back

=item purchaseType

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/itemsearch/

=head2 booksbooksearch

=head3 Parameters

=over

=item callBack

=over

=item type: String

=back

=item title

=over

=item type: String

=back

=item author

=over

=item type: String

=back

=item publisherName

=over

=item type: String

=back

=item size

=over

=item type: int

=item default: 0

=back

=item isbn

=over

=item type: long

=back

=item booksGenreId

=over

=item type: String

=item default: 001

=back

=item hits

=over

=item type: int

=item default: 30

=back

=item page

=over

=item type: int

=item default: 1

=back

=item availability

=over

=item type: int(1)

=item default: 0

=back

=item outOfStockFlag

=over

=item type: int(1)

=item default: 0

=back

=item sort

=over

=item type: String

=item default: 'standard'

=back

=item carrier

=over

=item type: int(1)

=item default: 0

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksbooksearch/

=head2 booksgenresearch

=head3 Parameters

=over

=item booksGenreId B<(required)>

=over

=item type: String

=back

=back



=head3 Full Documentation

http://affiliate.rakuten.co.jp/booksgenresearch/


=head1 AUTHOR

Dylan Doxey, E<lt>dylan.doxey@gmail.comE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 2009 by Dylan Doxey

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.8 or,
at your option, any later version of Perl 5 you may have available.

=cut
